var MOUSE = {ready: false, move: function(event){}, doubleclick: function(event) {}, mouseup: function(event){}, mousedown: function(event){}, init: function() {
	MOUSE = (function() {
		var last_click = -1;
		var has_left = false;
		function send(name, x, y) {
			if (ready) {
				var coords = DIMENSIONS.coordinates(x, y);
				if (coords.isvalid) {
					xmlhttp.open("PUT", name + "?x=" + coords.x + "&y=" + coords.y + "&width=" + coords.width+ "&height=" + coords.height,true);
					xmlhttp.send();
				}
			}
		}
		function stopEvent(event) {
			try {event.preventDefault(); } catch (e){}
			try {event.cancelBubble = true; } catch (e){}
			try {event.stopPropagation(); } catch (e){}
			return false;
		}
		function touchmoveEvent(event) {
			send("touchmove", event.touches[0].screenX, event.touches[0].screenY);
			return stopEvent(event);
		}
		function mouseOverEvent(event) {
			//send("move", event.pageX, event.pageY);
			return stopEvent(event);
		}
		function mouseup(event) {
			var d = new Date();
			if (event.which ==3) {
				send("rightclick", event.pageX, event.pageY);
			} else if (d.getTime() - last_click < 2000) {
				send("doubleclick", event.pageX, event.pageY);
				last_click = -1;
			} else {
				last_click = d.getTime();
				send("click", event.pageX, event.pageY);
			}
			return stopEvent(event);
		}
		function doubleclick(event) {
			//send("doubleclick", event.pageX, event.pageY);
			last_click = -1;
			return stopEvent(event);
		}
		function mousedown(event) {
			return stopEvent(event);
		}
		return {
			move: function(event) {
				if (event.touches) {
					touchmoveEvent(event);
				} else {
					mouseOverEvent(event);
				}
			},
			mouseup: mouseup,
			mousedown: mousedown,
			doubleclick: doubleclick
		}
}).call()}};